<template>
  <div class="item-grid" :class="[swiperslide != null ? swiperslide : '']">
    <div class="content-top">
      <div class="image-container">
        <nuxt-link
          v-if="product.cur_sku !== null"
          class="ava"
          :to="'/' + product.shared_url + '?option=' + product.cur_sku"
        >
          <img
            v-if="product.thumbnail != '/'"
            class="lazyload"
            data-sizes="auto"
            :data-srcset="
              $device.isMobile
                ? resizeImage(baseImageUrl + product.thumbnail, 147, 147)
                : resizeImage(baseImageUrl + product.thumbnail, 210, 210) +
                  ' 300w'
            "
            src="placeholder.jpg"
            alt="product image"
          />
          <img v-else src="placeholder.jpg" alt="product image" />
        </nuxt-link>
        <nuxt-link v-else class="ava" :to="'/' + product.shared_url">
          <img
            v-if="product.thumbnail != '/'"
            class="lazyload"
            data-sizes="auto"
            :data-srcset="
              $device.isMobile
                ? resizeImage(baseImageUrl + product.thumbnail, 147, 147)
                : resizeImage(baseImageUrl + product.thumbnail, 210, 210) +
                  ' 300w'
            "
            src="placeholder.jpg"
            alt="product image"
          />
          <img v-else src="placeholder.jpg" alt="product image" />
        </nuxt-link>
      </div>
    </div>
    <div class="content-bottom">
      <nuxt-link
        v-if="product.cur_sku !== null"
        class="name"
        :to="'/' + product.shared_url + '?option=' + product.cur_sku"
      >
        {{ product.name }}
      </nuxt-link>
      <nuxt-link
        v-else
        class="name"
        :to="'/' + product.shared_url + '?option=' + product.cur_sku"
      >
        {{ product.name }}
      </nuxt-link>
      <div v-if="product.sku" class="code">SKU: {{ product.sku }}</div>
      <div class="number-options">
        <strong>{{ product.number_options }}</strong>
        cấu hình tùy chọn
      </div>
      <div class="product-price">
        <div class="price">
          <span v-if="product.from_price !== null">Giá từ:</span>
          <strong>
            {{ (product.sale_from_price || product.from_price) | formatNumber }}
          </strong>
        </div>
        <div v-if="product.sale_from_price" class="price_old">
          {{ product.from_price | formatNumber }}
        </div>
      </div>
      <div v-if="product.options.length > 1" class="variant-label">
        <svg-icon name="color-wheel"></svg-icon>
        <span>Nhiều màu sắc</span>
      </div>
      <div class="content-more">
        <div v-if="product.options.length > 1" class="changer_color">
          <div>{{ isColor }}</div>
          <ul>
            <li
              v-for="(option, index) in product.options"
              :key="index"
              :class="index === 0 ? 'active' : ''"
            >
              <a href="javascript:;" @mouseenter="changeColor(option.color)">
                <img
                  v-if="option.thumbnail != '/'"
                  :data-srcset="
                    resizeImage(baseImageUrl + option.thumbnail, 32, 32)
                  "
                  class="lazyload"
                  alt="color"
                />
                <img v-else src="placeholder.jpg" alt="color" />
              </a>
            </li>
          </ul>
        </div>
        <div v-if="product.outstandings.length" class="desc-global">
          <span v-for="(out, index) in product.outstandings" :key="out">
            {{ out }}{{ product.outstandings.length - 1 > index ? ', ' : '' }}
          </span>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import Helper from '../../assets/config'

export default {
  name: 'ProductItemGrid',
  // eslint-disable-next-line vue/require-prop-types
  props: ['product', 'swiperslide'],
  data() {
    return {
      isColor: '',
    }
  },
  computed: {
    baseImageUrl() {
      return Helper.baseImageUrl
    },
  },
  mounted() {
    if (this.product.options.length > 0) {
      this.isColor = this.product.options[0].color
    }
  },
  methods: {
    resizeImage(url, width, height) {
      return Helper.resizeImage(url, width, height)
    },
    changeColor(color) {
      this.isColor = color
    },
  },
}
</script>
